/*********************************************************************************
* Copyright(C),2019, TUYA www.tuya.com

* FileName:		tuya_ipc_img_defs.h
* Note			tuya img lib basic defs 
* Version		V1.0.0
* Data			2019.12
**********************************************************************************/

#ifndef _TUYA_IPC_IMG_DEFS_H_
#define _TUYA_IPC_IMG_DEFS_H_

#include "tuya_cloud_types.h" 
#include "tuya_cloud_error_code.h"

/*  */
#ifdef __cplusplus
extern "C" {
#endif

    /*********************************************************************************
    * Image type
    * Y				
    * YUV	
    * BGR
    **********************************************************************************/
    typedef enum
    {
        Y = 1,
        YUV,
        UYUV,
        BGR888,
        RGB888,
        ARBG1555,
    }IMG_TYPE;

    /*********************************************************************************
    * data channel type
    **********************************************************************************/
    typedef enum
    {
        TUYA_U8 =1,
        TUYA_U16,
        TUYA_S32,
        TUYA_U32,
        TUYA_S64,

        TUYA_3U8,
        TUYA_3U16,
        TUYA_3S32,
        TUYA_3U32,
        TUYA_3S64,

    }CHANNEL_TYPE;

    /*********************************************************************************
    * Coordinate of pixels
    **********************************************************************************/
    typedef struct _TUYA_POINT
    {
        INT_T x;
        INT_T y;

    }TUYA_POINT;

    /*********************************************************************************
    * ROI of Motion Detect
    * x y  				Percent of pixels' coordinate
    * width				Percent of width
    * height 			Percent of height
    **********************************************************************************/
    typedef struct _TUYA_RPERCENT_RECT
    {
        INT_T x_percent;      
        INT_T y_percent;      
        INT_T width_percent;  
        INT_T height_percent; 

    }TUYA_RPERCENT_RECT;

    /*********************************************************************************
    * rect of TUYA  AI
    **********************************************************************************/
    typedef struct _TUYA_AI_RECT
    {
        INT_T left;
        INT_T top;
        INT_T right;
        INT_T bottom;
    }TUYA_AI_RECT;


#ifdef __cplusplus
}
#endif

#endif // !_TUYA_IPC_IMG_DEFS_H_
